{-# LANGUAGE FlexibleContexts, TemplateHaskell, TypeFamilies, OverloadedStrings #-}
module PRBAC where

import GHC.Generics
import Generics.BiGUL
import Generics.BiGUL.Interpreter
import Generics.BiGUL.TH
import Generics.BiGUL.Lib
import Data.List
import Control.Monad.Except
import Data.Maybe
import qualified Data.Map as Map
import Data.List
-- General datatypes for relational data


data Policy = Pol Role DataPermission Purpose Condition Obligation
                                                      deriving(Show)

data Role = Rol String                                deriving(Show)
data DataPermission = DP (String, String)             deriving(Show)
data Purpose = Pur String | PNull                     deriving(Show)
data Condition = Con ((String, String),String) | CNull       deriving(Show)
data Obligation = Obl String | ONull                  deriving(Show)

deriveBiGULGeneric ''Role
deriveBiGULGeneric ''DataPermission
deriveBiGULGeneric ''Purpose
deriveBiGULGeneric ''Condition
deriveBiGULGeneric ''Obligation
deriveBiGULGeneric ''Policy

pararole :: Policy -> String
pararole (Pol (Rol str) _ _ _ _) = str

paraaction :: Policy -> String
paraaction (Pol _ (DP (str, _)) _ _ _) = str

paradata :: Policy -> String
paradata (Pol _ (DP (_, str)) _ _ _) = str

parapurpose :: Policy -> String
parapurpose p = case p of
                Pol _ _ (Pur str) _ _ -> str
                Pol _ _ PNull _ _ -> ""

paracondition :: Policy -> ((String,String),String)
paracondition p = case p of
                Pol _ _ _ (Con tmp) _ -> tmp
                Pol _ _ _ CNull _ -> (("",""),"")

paraobligation :: Policy -> String
paraobligation p = case p of 
                Pol _ _ _ _ (Obl str)-> str
                Pol _ _ _ _ ONull -> ""






